#include "Actor.h"
#include <string>
#include "MessageManager.h"
#include "AAPlatform.h"
#include "ActorFactory.h"
#include "ActorName.h"
#include "RoleRecruiter.h"
#include <iostream>
using namespace std;

// Implementation skeleton constructor
Actor::Actor ()
{
	
}

// Implementation skeleton destructor
Actor::~Actor (void)
{

}


void Actor::send (string destActorName,string message)
{
	MessageManager::Instance()->send(name.uan,destActorName, message);
}

void Actor::sendUnconstrained(string destActorName,string message)
{
	MessageManager::Instance()->sendUnconstrained(name.uan,destActorName, message);
}

string Actor::call(string destActorName,string message)
{
	return MessageManager::Instance()->call(name.uan,destActorName,message);
}

ActorName Actor::create (string actorName)
{
	return ActorFactory::Instance()->CreateActor(actorName);
}

	
void Actor::become (string state)
{
	manageRoleMembership();
}

void Actor::setName(ActorName value)
{
printf("\n in set name");
	name = value;
	manageRoleMembership();
printf("\n exit set name");
}

ActorName Actor::getName()
{
	return name;
}

criteria Actor::getBehavior()
{
	return behavior;
}

void Actor::manageRoleMembership()
{
	cout << "manageRoleMembership() -> " << name.uan << endl;

	RoleRecruiter *coord = RoleRecruiter::Instance();
	
	string newRole = coord->getRole(behavior);
	
	//if role changed
	if(role != newRole)
	{
		//if there was a previous role, leave it
		if(role != "")
		{
			call(role,"leave|" + name.uan);
		}

		role = newRole;
		
		//join the new role
		call(newRole,"join|" + name.uan);
	}

}

string Actor::getRole()
{
	return role;
}
