#ifndef ACTOR_H_
#define ACTOR_H_

#include <string>
#include "ActorName.h"
#include "Criteria.h"
#include <iostream>

using namespace std;

class  Actor
{
public:
  //Constructor 
  Actor ();
  
  //Destructor 
  virtual ~Actor ();
  
  void send (string destActorName,string message);

  void sendUnconstrained(string destActorName,string message);

  string call(string destActorName, string message);

  ActorName create (string actorName);
  
  virtual void become (string state);

  virtual void handle (string sender, string message)
  {
	  cout << "This should never be seen!" << " "<<sender<<" "<<message<<endl;
  }

  virtual string handle_synch(string sender, string message)
  {
	  return role;
  };

  virtual void setName(ActorName value);

  ActorName getName();

  criteria getBehavior(); 	// *~*~* doesnt it need an object to access a member function?

  string getRole();

protected:
	ActorName name;

	criteria behavior;

	string role;

	void manageRoleMembership();

};


#endif /* ACTOR_H_  */
