#include "ActorFactory.h"
#include "Actor.h"
#include "ConcurrentPing.h"
#include "ConcurrentPong.h"
#include "PingActor.h"
#include "PongActor.h"
#include <iostream>
#include <string>
//#include "ActorFactoryThread.h"
#include "UANManager.h"
#include "Coordinator.h"
#include "CRFDM.h"
#include "RRFDM.h"
#include "HelloWorldPrinter.h"
#include "HelloWorldPrinterRole.h"
#include "HelloWorldPrinterRRFDM.h"
#include "HelloWorldSender.h"
#include "HelloWorldSenderType1Role.h"
#include "HelloWorldSenderType1RRFDM.h"
#include "HelloWorldSenderType2Role.h"
#include "HelloWorldSenderType2RRFDM.h"

using namespace std;

ActorFactory* ActorFactory::pinstance = 0;

ActorFactory* ActorFactory::Instance()
{
	if (pinstance == 0)
		pinstance = new ActorFactory();

	return pinstance;
}

void *StartFactory(void* aFThread)
{
	
	//ActorFactoryThread orbThread;

	ActorFactory *aFactory = (ActorFactory*)aFThread;
	//aFactory->orbThread = new ActorFactoryThread();
	//orbThread = ActorFactoryThread();
	// Incase of thread, this would be the first thing it would call
	(aFactory->orbThread)->run();
	//aFactory->orbThread.run();
	



	cout << "Actor factory created." << endl;


	return 0;
}

ActorFactory::ActorFactory()
{
	orbThread = new ActorFactoryThread();
	//orbThread->start();
	
	int aft = pthread_create(&actorFactoryThread, NULL, StartFactory, (void*)this);	

	if (aft){
         printf("### ERROR : PThread %d as not been created for Actory Factory\n", aft);
         exit(-1);
      	}
	else
	{

		printf("\n Thread created");
	}

       while(!orbThread->isDone())
	{
		//do nothing
	}

//	aFactory->poa = aFactory->orbThread.getPOA();
//	aFactory->namingRoot1 = aFactory->orbThread.getNameService();

	poa = orbThread->getPOA();
	namingRoot1 = orbThread->getNameService();

	//pthread_join( actorFactoryThread, NULL);
	
}

ActorFactory::~ActorFactory()
{
	// When pthread exits, orbthread will automatically get destroyed
	 pthread_exit(NULL);

	//delete orbThread;
//	orbThread = 0;
}

ActorName ActorFactory::CreateActor(string actorName)
{
	try
	{
		Actor *actor=0;
		bool simpleName = false;
		bool bindRemotely = true;

		if (actorName == "PingActor")
		{
//			cout<<"Ping Actor out of commission for now";
			actor = new PingActor();
		}
		else if (actorName == "PongActor")
		{
//			cout<<"Pong Actor out of commission for now";
			actor = new PongActor();
		}
		else if (actorName == "ConcurrentPing")
		{
			actor = new ConcurrentPing();
		}
		else if (actorName == "ConcurrentPong")
		{
			actor = new ConcurrentPong();
		}
		else if (actorName == "Coordinator")
		{
			
			actor = new Coordinator();
			simpleName = true;
			
		}
		else if (actorName == "CRFDM")
		{
			actor = new CRFDM();
			simpleName = false;
			bindRemotely = true;
		}
		else if(actorName == "HelloWorldPrinter")
		{
			actor = new HelloWorldPrinter();
		}
		else if(actorName == "HelloWorldSender")
		{
			actor = new HelloWorldSender();
		}
		else if(actorName == "HelloWorldSenderType1Role")
		{
			actor = new HelloWorldSenderType1Role();
			simpleName = true;
		}
		else if(actorName == "HelloWorldSenderType2Role")
		{
			actor = new HelloWorldSenderType2Role();
			simpleName = true;
		}
		else if(actorName == "HelloWorldSenderType1RRFDM")
		{
			actor = new HelloWorldSenderType1RRFDM();
			simpleName = true;
			bindRemotely = !(AAPlatform::Instance()->getMode() == ARC_MODE_FDM);
		}
		else if(actorName == "HelloWorldSenderType2RRFDM")
		{
			actor = new HelloWorldSenderType2RRFDM();
			simpleName = true;
			bindRemotely = !(AAPlatform::Instance()->getMode() == ARC_MODE_FDM);
		}
		else if(actorName == "HelloWorldPrinterRole")
		{
			actor = new HelloWorldPrinterRole();
			simpleName = true;
		}
		else if(actorName == "HelloWorldPrinterRRFDM")
		{
			actor = new HelloWorldPrinterRRFDM();
			simpleName = true;
			bindRemotely = !(AAPlatform::Instance()->getMode() == ARC_MODE_FDM);
		}
		else if (actorName == "PingRoleRRFDM")
		{
			actor = new RRFDM("PingRole");
			simpleName = true;
			bindRemotely = !(AAPlatform::Instance()->getMode() == ARC_MODE_FDM);
		}
		else if (actorName == "PongRoleRRFDM")
		{
			actor = new RRFDM("PodngRole");
			simpleName = true;
			bindRemotely = !(AAPlatform::Instance()->getMode() == ARC_MODE_FDM);
		}
		else
		{
			ActorName failed;
			failed.id = -1;
			failed.type = "";
			failed.uan = "";
			cerr << "Unknown actor type " << actorName << endl;
			return failed;
		}
		
		ActorName name = UANManager::Instance()->generateName(actorName,actor,simpleName);		
		actor->setName(name);

		if(bindRemotely)
		{
printf("\n binding remotely");
			Messenger_i *servant = new Messenger_i(actor);
			printf("\n servant");
			//PortableServer::ObjectId_var oid = poa->activate_object(servant);
			//CORBA::Object_var objRef = poa->id_to_reference(oid.in());
	printf("\n after servant");	
		
			CORBA::Object_var objRef = poa->servant_to_reference(servant);
			
			printf("\n Exception");
	
printf("\n object var");
			CosNaming::Name objName;
			objName.length(2);
			objName[0].id = CORBA::string_dup("example");
			objName[1].id = CORBA::string_dup(name.uan.c_str());
			namingRoot1->rebind(objName,objRef.in());

			//mutex.unlock();
			//cout << "Bound IOR " << endl << orbThread->getORB()->object_to_string(objRef) << endl;
			cout << name.uan << " bound in Naming Service." << endl;
		}
		else
		{
			cout << name.uan << " created locally." << endl;
		}

		return name;
	}
	catch(CORBA::Exception& ex)
	{
		cerr << "ActorFactory CORBA Exception: " << ex << endl;
	}
ActorName failed;
			failed.id = -1;
			failed.type = "";
			failed.uan = "";
			cerr << "Unknown actor type " << actorName << endl;
			return failed;


}

void ActorFactory::listActors(vector<ActorName> &data)
{
	UANManager::Instance()->getActorNames(data);
}

