#ifndef ACTORFACTORY_H_
#define ACTORFACTORY_H_

#include <string>
#include <vector>
#include <map>
#include <pthread.h>
#include "ActorFactoryThread.h"
#include "ActorName.h"
#include "ORBThreadPool.h"
#include "tao/ORB_Core.h"
#include "ace/Log_Msg.h"
#include "orbsvcs/CosNamingC.h"
#include "orbsvcs/Naming/Naming_Server.h"
#include "tao/Utils/ORB_Manager.h"
#include "ace/Get_Opt.h"
#include "utility.h"
#include "MessengerI.h"

class ActorFactoryThread;

using namespace std;

class ActorFactory 
{

public:
	static ActorFactory* Instance();

	~ActorFactory();

	ActorName CreateActor(string actorName);

	void listActors(vector<ActorName> &data);
	
	ActorFactoryThread *orbThread;

	PortableServer::POA_var poa;		

	CosNaming::NamingContext_var namingRoot1;
	
	pthread_t actorFactoryThread;

      

protected:
	ActorFactory();

private:

	static ActorFactory *pinstance;
	
	
	
};



#endif /* ACTORFACTORY_H_  */

