#include "CRBase.h"
#include <vector>
#include "utility.h"

CRBase::CRBase()
{
		pthread_mutex_init(&pStateMutex, NULL);
	behavior.operations.push_back("ask");
	behavior.operations.push_back("lock");
	behavior.operations.push_back("unlock");
	behavior.operations.push_back("update");
}

CRBase::~CRBase()
{

}

string CRBase::handle_synch(string sender, string message)
{
	vector<string> data = Utility::split(message,'|');

	if(data[0] == "ask")
	{
	//	stateMutex.lock();
		pthread_mutex_lock(&pStateMutex);
		string result = ask(data[1],data[2],data[3],data[4],data[5],data[6]);
		pthread_mutex_unlock (&pStateMutex);	
		//stateMutex.unlock();
		return result;
	}
	
	if(data[0] == "lock")
	{
		//stateMutex.lock();
		pthread_mutex_lock(&pStateMutex);		
		return "";
	}

	if(data[0] == "unlock")
	{
	//	stateMutex.unlock();
		pthread_mutex_unlock (&pStateMutex);		
		return "";
	}

	if(data[0] == "update")
	{
		updateState(data[1],data[2]);
		return "";
	}

	return "";
}

void CRBase::setName(ActorName value)
{
	Actor::setName(value);

	call("Coordinator","register|" + value.uan);
}

void CRBase::updateState(string stateName,string value)
{
	//update the state here
	cout << "Update state: " << stateName << " Value: " << value << endl;

	if(stateName == "resource")
	{
		resourceConflict = (value == "conflict");
	}
}

void CRBase::handle(string sender, string message)
{
	vector<string> data = Utility::split(message,'|');

	if(data[0] == "setResource")
	{
		call("Coordinator","update|resource|" + data[1]);
	}
}
