#include "Coordinator.h"
#include "utility.h"

Coordinator::Coordinator()
{
	pthread_mutex_init(&pUpdateMutex, NULL);
	behavior.operations.push_back("update");
	behavior.operations.push_back("register");
	behavior.operations.push_back("setResource");

}

Coordinator::~Coordinator()
{

}

string Coordinator::handle_synch(string sender, string message)
{
	vector<string> data = Utility::split(message,'|');

	if(data[0] == "update")
	{
		manageStateUpdate(data[1],data[2]);
	}
	else if(data[0] == "register")
	{
	//	updateMutex.lock();
		pthread_mutex_lock(&pUpdateMutex);
		representatives.push_back(data[1]);
		cout << data[1] << " registered with the Coordinator." << endl;
		pthread_mutex_unlock (&pUpdateMutex);			
		//updateMutex.unlock();
	}

	return "";
}

void Coordinator::handle(string sender, string message)
{
	vector<string> data = Utility::split(message,'|');

	if(data[0] == "setResource")
	{
		manageStateUpdate("resource",data[1]);
	}
}

void Coordinator::manageStateUpdate(string stateName,string value)
{
	cout << "Updating coordinator state" << endl;
	//updateMutex.lock();
	pthread_mutex_lock(&pUpdateMutex);
	//lock all the representatives
	cout << "Locking CR's..." << endl;
	int i;
	for(i = 0; i < (int)representatives.size(); i++)
	{
		call(representatives[i],"lock");
	}

	cout << "Sending updates..." << endl;
	//updating internal coordinator state
	updateState(stateName,value);

	//send update notifications to all the representatives
	for(i = 0; i < (int)representatives.size(); i++)
	{
		call(representatives[i],"update|" + stateName + "|" + value);
	}

	cout << "Unlocking CR's..." << endl;
	//unlock all the representatives
	for(i = 0; i < (int)representatives.size(); i++)
	{
		call(representatives[i],"unlock");
	}
	pthread_mutex_unlock (&pUpdateMutex);	
	//updateMutex.unlock();
}

void Coordinator::updateState(string stateName, string value)
{
	if(stateName == "resource")
	{
		resourceConflict = (value == "conflict");
	}
}
