#include "HelloWorldPrinterRole.h"
#include "AAPlatform.h"
#include "utility.h"
#include <vector>

HelloWorldPrinterRole::HelloWorldPrinterRole(): RoleBase()
{
	behavior.operations.push_back("setQoSLevel");
}

HelloWorldPrinterRole::~HelloWorldPrinterRole()
{

}

void HelloWorldPrinterRole::updateState(string stateName, string value)
{
	if(stateName == "qosLevel")
	{
		qosLevel = (value == "high");
		cout << "QosLevel set to " << value;
	}
}

string HelloWorldPrinterRole::check_constraints(string destinationActor, string operation,
	string parameters, string senderActor, string senderRole,
	string destinationRole)
{
	cout << "HelloWorldPrinterRole" << endl;

	//check constraints here
	//do whatever checking constraints requires you to do

	if(senderRole == "HelloWorldSenderType1Role" && (!qosLevel))
	{
		call(destinationActor,"setRepeatFalse");
	}
	else if(senderRole == "HelloWorldSenderType1Role" && qosLevel)
	{
		call(destinationActor,"setRepeatTrue");
	}
	else if(senderRole == "HelloWorldSenderType2Role")
	{
		call(destinationActor,"setRepeatTrue");
	}

	//prepare the event to send to the CR
	string event = "ask|constraintType|HelloWorldPrinterRole|" + operation + "|" + parameters + "|" + senderRole + "|" + destinationRole;

	//get the name of the CR
	string crName = AAPlatform::Instance()->getCR();

	//send the event to the CR
	string crResult = call(crName,event);

	//combine the result from checking the constraints here with the result from the CR
	//and return that back

	return "";
}

void HelloWorldPrinterRole::handle(string sender, string message)
{
	
}

string HelloWorldPrinterRole::handle_synch(string sender, string message)
{
	vector<string> data = Utility::split(message,'|');

	if(data[0] == "setQoSLevel")
	{
		synchronizeStateUpdate("qosLevel",data[1]);
		return "";
	}
	else
		return RoleBase::handle_synch(sender, message);
}

