#include "HelloWorldSenderType1RRFDM.h"
#include "utility.h"
#include <vector>

HelloWorldSenderType1RRFDM::HelloWorldSenderType1RRFDM(): RRFDM("HelloWorldSenderType1Role")
{
	behavior.operations.push_back("setWeather");
}

HelloWorldSenderType1RRFDM::~HelloWorldSenderType1RRFDM()
{

}

string HelloWorldSenderType1RRFDM::check_constraints(string destinationActor, string operation,
	string parameters, string senderActor, string senderRole,
	string destinationRole)
{
	RRFDM::check_constraints(destinationActor,operation,parameters,senderActor,senderRole,destinationRole);

	cout << "HelloWorldSenderType1RRFDM is checking the constraints..." << endl;

	//printing some stuff
	if(weather == "good")
	{
		cout << "Send Hello World Type 1 in good weather." << endl;
	}
	else if(weather == "bad")
	{
		cout << "Send Hello World Type 1 in bad weather." << endl;
	}
	else
	{
		cout << "Send Hello World Type 1 in normal weather." << endl;
	}

	return "";
}

void HelloWorldSenderType1RRFDM::updateState(string stateName, string value)
{
	if(stateName == "weather")
	{
		weather = value;
		cout << "HelloWorldSenderType1RRFDM weather set to " << value << endl;
	}
}

void HelloWorldSenderType1RRFDM::handle(string sender, string message)
{
	vector<string> data = Utility::split(message,'|');

	if(data[0] == "setWeather")
	{
		string event = "update|weather|" + data[1];
		call(getOwnerRole(),event);
	}
	else
		RRFDM::handle(sender,message);
}

