#include "HelloWorldSenderType2Role.h"
#include "AAPlatform.h"
#include "utility.h"
#include <vector>

HelloWorldSenderType2Role::HelloWorldSenderType2Role(): RoleBase()
{
	behavior.operations.push_back("setWeather");
}

HelloWorldSenderType2Role::~HelloWorldSenderType2Role()
{

}

void HelloWorldSenderType2Role::updateState(string stateName, string value)
{
	//updating the state variable
	if(stateName == "weather")
	{
		weather = value;
		cout << "HelloWorldSenderType2Role weather set to " << value << endl;
	}
}

string HelloWorldSenderType2Role::check_constraints(string destinationActor, string operation,
	string parameters, string senderActor, string senderRole,
	string destinationRole)
{
	cout << "HelloWorldSenderType2Role" << endl;

	//check constraints here
	//do whatever checking constraints requires you to do

	//prepare the event to send to the CR
	string event = "ask|constraintType|HelloWorldSenderType2Role|" + operation + "|" + parameters + "|" + senderRole + "|" + destinationRole;

	//get the name of the CR
	string crName = AAPlatform::Instance()->getCR();

	//send the event to the CR
	string crResult = call(crName,event);

	//combine the result from checking the constraints here with the result from the CR
	//and return that back

	cout << "HelloWorldSenderType2Role constraints done." << endl;

	//printing some stuff
	if(weather == "good")
	{
		cout << "Send Hello World Type 2 in good weather." << endl;
	}
	else if(weather == "bad")
	{
		cout << "Send Hello World Type 2 in bad weather." << endl;
	}
	else
	{
		cout << "Send Hello World Type 2 in normal weather." << endl;
	}

	return "";
}

void HelloWorldSenderType2Role::handle(string sender, string message)
{
	vector<string> data = Utility::split(message,'|');

	if(data[0] == "setWeather")
	{
		if(data[1] == "good")
		{
			synchronizeStateUpdate("weather","good");
		}
		else if(data[1] == "bad")
		{
			synchronizeStateUpdate("weather","bad");
		}
		else
		{
			synchronizeStateUpdate("weather","normal");
		}
	}
	else
		RoleBase::handle(sender,message);
}
