// -*- C++ -*-
//
// $Id$

// ****  Code generated by the The ACE ORB (TAO) IDL Compiler ****
// TAO and the TAO IDL Compiler have been developed by:
//       Center for Distributed Object Computing
//       Washington University
//       St. Louis, MO
//       USA
//       http://www.cs.wustl.edu/~schmidt/doc-center.html
// and
//       Distributed Object Computing Laboratory
//       University of California at Irvine
//       Irvine, CA
//       USA
//       http://doc.ece.uci.edu/
// and
//       Institute for Software Integrated Systems
//       Vanderbilt University
//       Nashville, TN
//       USA
//       http://www.isis.vanderbilt.edu/
//
// Information about TAO is available at:
//     http://www.cs.wustl.edu/~schmidt/TAO.html

// TAO_IDL - Generated from 
// C:\ACE_wrappers\TAO\TAO_IDL\be\be_codegen.cpp:1030

#include "MessengerI.h"
#include <iostream>
#include <string>
#include "ActorFactory.h"
#include "AAPlatform.h"
#include "utility.h"
#include <vector>

using namespace std;

// TAO_IDL - Generated from
// C:\ACE_wrappers\TAO\TAO_IDL\be\be_visitor_interface/interface_is.cpp:52

// Implementation skeleton constructor
Messenger_i::Messenger_i (Actor *attachedActor)
{
	actor = attachedActor;
}

// Implementation skeleton destructor
Messenger_i::~Messenger_i (void)
{

}

// TAO_IDL - Generated from
// C:\ACE_wrappers\TAO\TAO_IDL\be\be_visitor_operation/operation_is.cpp:57

void Messenger_i::asynchronous_message (
    const char * dest_actor,
    const char * senderChar,
    const char * taggedMessage
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ))
{
	cout << "MessageManager received the message." << endl;

	vector<string> parsedTags = Utility::split(taggedMessage,'|',2);
	string message = parsedTags[1];

	string sender = senderChar;
	
	//get the actor's uan
	string actorName = actor->getName().uan;

	string senderRole;
	string receiverRole;

	if(sender == "AAPlatform")
	{
		senderRole = "";
		receiverRole = "";
	}
	else
	{
		//figure out the sender role
		if(sender == "")
			senderRole = "";
		else
			senderRole = parsedTags[0];

		//figure out the receiver role
		receiverRole = actor->getRole();
	}

	//if receiver is constrained
	if(receiverRole != "")
	{
		//figure out the role representative
		string receiverRR = AAPlatform::Instance()->getRR(receiverRole);

		//prepare the event for sending
		string event = "check|" + actorName + "|" + message + "|parameters|" + sender + "|" + senderRole + "|" + receiverRole;

		string checkResult = actor->call(receiverRR,event);

		//do whatever you want with the constraint check result
		//the stuff to handle it goes here

		cout << "Constraint check is complete." << endl;
	}

	cout << "Message is being sent to the actor for processing..." << endl;

	actor->handle(sender,message);
}

// TAO_IDL - Generated from
// C:\ACE_wrappers\TAO\TAO_IDL\be\be_visitor_operation/operation_is.cpp:57

char * Messenger_i::synchronous_message (
    const char * dest_actor,
    const char * sender,
    const char * message
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ))
{
	CORBA::String_var ret = CORBA::string_dup(actor->handle_synch(sender,message).c_str());
	return ret._retn();
}

