#include "PingActor.h"
#include "MessageManager.h"
#include <iostream>
#include <string>
#include <ctime>
#include "ConcurrentPing.h"

using namespace std;

PingActor::PingActor()
{
	max = 10;

	for(int i = 0; i < (MESSAGE_SIZE - 1); i++)
		huge_msg[i] = (i % 10) + 48;
	huge_msg[MESSAGE_SIZE - 1] = 0;
	//cout << huge_msg << endl;

	behavior.operations.push_back("start");
	behavior.operations.push_back("make");
	behavior.operations.push_back("default");
}

void PingActor::handle(string sender,string message)
{
	string operation = message;
	
	if(operation.length() < 50)
	{

		if(operation == "start")
		{
			//startstart = GetTickCount();
			time(&start);
			counter = 0;
			send(destActor,huge_msg);
			cout << "Ping sent 0" << endl;
		}
		else if (operation == "make")
		{
			destActor = create("PongActor").uan;
			cout << "Using sender: " << destActor << endl;
		}
		else if (operation == "default")
		{
			destActor = "uan:PongActor:localhost:";

			char buffer[20];
			//itoa(name.id,buffer,10);

			sprintf(buffer,"%d",name.id);
			destActor += buffer;
			cout << "Using sender: " << destActor << endl;
		}
		else if (operation == "cc")
		{
			destActor = "uan:PongActor:stuff:";

			char buffer[20];
		//	itoa(name.id,buffer,10);
			sprintf(buffer,"%d",name.id);
			destActor += buffer;
			cout << "Using sender: " << destActor << endl;
		}
	}
	else
	{
		counter++;		
		cout << "Ping received " << counter << endl;

		counter++;

		if(counter < max)
		{
			send(destActor,huge_msg);
			cout << "Ping sent " << counter << endl;
		}
		else
		{
			//end = GetTickCount();
			time(&end);
			ConcurrentPing::startTimes[name.id-1] = start;
			ConcurrentPing::endTimes[name.id-1] = end;
			//int delta = end - start;
			float delta = difftime (end,start);	
			double avg = ((double)delta) / ((double)max);
			cout << "Messages transferred: " << max << endl;
			cout << "Total time: " << delta << " sec." << endl;
			cout << "Average message time: " << avg << endl;
		}
	}
}

