#include "PropertyReader.h"
#include <fstream>
#include "utility.h"

using namespace std;

PropertyReader::PropertyReader()
{
	arcMode = ARC_MODE_FDM;
	roleRepresentatives.clear();
	platformName = "localhost";
	namingService = "";
}

PropertyReader::~PropertyReader()
{

}

int PropertyReader::parseMode(string data)
{
	if(data == "FDM")
		return ARC_MODE_FDM;
	
	if(data == "PDM")
		return ARC_MODE_PDM;

	if(data == "FCM")
		return ARC_MODE_FCM;

	return ARC_MODE_INVALID;
}

void PropertyReader::parseRoleReps(string data)
{
	roleRepresentatives = Utility::split(data,',');
}

bool PropertyReader::readFile(string fileName)
{
	ifstream file;
	file.open(fileName.c_str());
	
	if(!file.is_open())
		return false;
	
	string key;
	string data;
	while(!file.eof())
	{
		file >> key;
		file >> data;

		if(key == "MODE")
		{
			arcMode = parseMode(data);
		}
		else if(key == "ROLE_REPRESENTATIVES")
		{
			parseRoleReps(data);
		}
		else if(key == "COORDINATOR_REPRESENTATIVE")
		{
			coordinatorRepresentative = data;
		}
		else if(key == "PLATFORM_NAME")
		{
			platformName = data;
		}
		else if(key == "NAMING_SERVICE")
		{
			namingService = data;
		}
		else if(key == "CREATE_COORDINATOR")
		{
			createCoordinator = (data == "YES");
		}
		else if(key == "ACTORS")
		{
			parseActors(data);
		}
		else if(key == "ROLES")
		{
			parseRoles(data);
		}
	}

	return true;
}

int PropertyReader::getMode()
{
	return arcMode;
}

string PropertyReader::getPlatformName()
{
	return platformName;
}

string PropertyReader::getNamingService()
{
	return namingService;
}

void PropertyReader::getRoleRepresentatives(vector<string> &data)
{
	data.clear();
	for(int i = 0; i < (int)roleRepresentatives.size(); i++)
		data.push_back(roleRepresentatives[i]);
}

string PropertyReader::getCoordinatorRepresentative()
{
	return coordinatorRepresentative;
}

bool PropertyReader::getCreateCoordinator()
{
	return createCoordinator;
}

void PropertyReader::getActors(vector<string> &data)
{
	data.clear();
	for(int i = 0; i < (int)actors.size(); i++)
		data.push_back(actors[i]);
}

void PropertyReader::parseActors(string data)
{
	actors = Utility::split(data,',');
}

void PropertyReader::getRoles(vector<string> &data)
{
	data.clear();
	for(int i = 0; i < (int)roles.size(); i++)
		data.push_back(roles[i]);
}

void PropertyReader::parseRoles(string data)
{
	roles = Utility::split(data,',');
}
