#ifndef PROPERTYREADER_H_
#define PROPERTYREADER_H_

#define ARC_MODE_INVALID (-1)
#define ARC_MODE_FDM 0
#define ARC_MODE_PDM 1
#define ARC_MODE_FCM 2

#include <iostream>
#include <string>
#include <vector>

using namespace std;

class PropertyReader
{
public:
	PropertyReader();

	~PropertyReader();

	bool readFile(string fileName);

	int getMode();

	string getPlatformName();

	void getRoleRepresentatives(vector<string> &data);

	string getCoordinatorRepresentative();

	string getNamingService();

	bool getCreateCoordinator();

	void getActors(vector<string> &data);

	void getRoles(vector<string> &data);

protected:
	
	int parseMode(string data);

	void parseRoleReps(string data);

	void parseActors(string data);

	void parseRoles(string data);

private:
	int arcMode;

	string platformName;

	string namingService;

	vector<string> roleRepresentatives;

	string coordinatorRepresentative;

	bool createCoordinator;

	vector<string> actors;

	vector<string> roles;
};

#endif

