#include "RRBase.h"
#include "utility.h"
#include <vector>

RRBase::RRBase(string roleIn)
{
	pthread_mutex_init(&pStateMutex, NULL);
	ownerRole = roleIn;

	behavior.operations.push_back("check");
}

RRBase::~RRBase()
{

}

string RRBase::handle_synch(string sender, string message)
{
	vector<string> data = Utility::split(message,'|');

	if(data[0] == "check")
	{
		return check_constraints(data[1],data[2],data[3],data[4],data[5],data[6]);
	}

	if(data[0] == "lock")
	{
		pthread_mutex_lock(&pStateMutex);
		//stateMutex.lock();
		return "";
	}

	if(data[0] == "unlock")
	{
		//stateMutex.unlock();
		pthread_mutex_unlock (&pStateMutex);		
		return "";
	}

	if(data[0] == "update")
	{
		updateState(data[1],data[2]);
		return "";
	}

	return "";
}

string RRBase::getOwnerRole()
{
	return ownerRole;
}

void RRBase::setName(ActorName value)
{
	Actor::setName(value);

	call(ownerRole,"register|" + value.uan);
}

void RRBase::handle(string sender, string message)
{

}
