#include "RoleBase.h"
#include "utility.h"

RoleBase::RoleBase()
{
	pthread_mutex_init(&pUpdateMutex, NULL);
	behavior.operations.push_back("join");
	behavior.operations.push_back("leave");
	behavior.operations.push_back("update");
	behavior.operations.push_back("register");
	behavior.operations.push_back("ask");
}

RoleBase::~RoleBase()
{

}

string RoleBase::handle_synch(string sender, string message)
{
	vector<string> data = Utility::split(message,'|');

	if(data[0] == "update")
	{
		synchronizeStateUpdate(data[1],data[2]);
	}
	else if(data[0] == "check")
	{
		return check_constraints(data[1],data[2],data[3],data[4],data[5],data[6]);
	}
	else if(data[0] == "join")
	{
	//	updateMutex.lock();
		pthread_mutex_lock(&pUpdateMutex);	
		actors.push_back(data[1]);
		cout << data[1] << " joined the " << name.uan << " role." << endl;
		pthread_mutex_unlock (&pUpdateMutex);			
		//updateMutex.unlock();
	}
	else if(data[0] == "leave")
	{
	//	updateMutex.lock();
		pthread_mutex_lock(&pUpdateMutex);
		actors.remove(data[1]);
		cout << data[1] << " left the " << name.uan << " role." << endl;
		pthread_mutex_unlock (&pUpdateMutex);		
	//	updateMutex.unlock();
	}
	else if(data[0] == "update")
	{
		synchronizeStateUpdate(data[1],data[2]);
	}
	else if(data[0] == "register")
	{
		//updateMutex.lock();
		pthread_mutex_lock(&pUpdateMutex);
		representatives.push_back(data[1]);
		cout << data[1] << " has registered with role " << name.uan << endl;
		pthread_mutex_unlock (&pUpdateMutex);	
	//	updateMutex.unlock();
	}

	return "";

}

void RoleBase::synchronizeStateUpdate(string stateName,string value)
{
	cout << "Updating role state" << endl;
	//updateMutex.lock();
	pthread_mutex_lock(&pUpdateMutex);

	//lock all the representatives
	cout << "Locking RR's..." << endl;
	int i;
	for(i = 0; i < (int)representatives.size(); i++)
	{
		call(representatives[i],"lock");
	}

	cout << "Sending updates..." << endl;
	//send update notifications to all the representatives
	for(i = 0; i < (int)representatives.size(); i++)
	{
		updateState(stateName,value);
		call(representatives[i],"update|" + stateName + "|" + value);
	}

	cout << "Unlocking RR's..." << endl;
	//unlock all the representatives
	for(i = 0; i < (int)representatives.size(); i++)
	{
		call(representatives[i],"unlock");
	}
	pthread_mutex_unlock (&pUpdateMutex);	
//	updateMutex.unlock();
}
