#ifndef ROLEBASE_H_
#define ROLEBASE_H_
#include "Actor.h"

#include <pthread.h>
#include <vector>
#include <list>

class RoleBase: public Actor
{
public:
	RoleBase();

	~RoleBase();

	string handle_synch(string sender, string message);

	void synchronizeStateUpdate(string stateName,string value);

	virtual void updateState(string stateName, string value) = 0;

	virtual string check_constraints(string destinationActor, string operation,
		string parameters, string senderActor, string senderRole,
		string destinationRole) = 0;

private:
	//OpenThreads::Mutex updateMutex;
	pthread_mutex_t pUpdateMutex;


	list<string> actors;
	vector<string> representatives;
};

#endif 
