#include "RoleRecruiter.h"

#define MESSAGE_SIZE 1024

RoleRecruiter *RoleRecruiter::pinstance = 0;

RoleRecruiter *RoleRecruiter::Instance()
{
	if(pinstance == 0)
		pinstance = new RoleRecruiter();

	return pinstance;
}

RoleRecruiter::RoleRecruiter()
{
	int i;

	criteria ping;
	ping.operations.push_back("start");
	ping.operations.push_back("make");
	ping.operations.push_back("default");

	criteria pingLike;
	pingLike.operations.push_back("start3");
	pingLike.operations.push_back("make");
	pingLike.operations.push_back("default");

	criteria pong;

	criteria pongLike;
	pongLike.operations.push_back("A");

	criteria dummy;
	dummy.attributes["test1"] = "stuff";
	dummy.attributes["test2"] = "more stuff";
	dummy.operations.push_back("doStuff");
	dummy.operations.push_back("doSomeOtherStuff");
	
	for(i = 0; i < 500; i++)
	{
		constraints.push_back(dummy);
		roles.push_back("dummyRole");
	}	
	
	for(i = 0; i < 250; i++)
	{
		constraints.push_back(pingLike);
		roles.push_back("pingLike");
		constraints.push_back(pongLike);
		roles.push_back("pongLike");
	}

	constraints.push_back(ping);
	roles.push_back("PingRole");
	constraints.push_back(pong);
	roles.push_back("PongRole");

	criteria type1;
	type1.operations.push_back("start");
	type1.operations.push_back("startType2");
	type1.attributes["type"] = "1";

	criteria type2;
	type2.operations.push_back("start");
	type2.operations.push_back("startType2");
	type2.attributes["type"] = "2";

	constraints.push_back(type1);
	roles.push_back("HelloWorldSenderType1Role");
	constraints.push_back(type2);
	roles.push_back("HelloWorldSenderType2Role");

	criteria printer;
	printer.operations.push_back("printHelloWorld");
	printer.operations.push_back("setRepeatTrue");
	printer.operations.push_back("setRepeatFalse");
	constraints.push_back(printer);
	roles.push_back("HelloWorldPrinterRole");
}

RoleRecruiter::~RoleRecruiter()
{

}

string RoleRecruiter::getRole(criteria &behavior)
{
	//temporarily disabled
	//return "";

	int behavAttrs = behavior.attributes.size();
	int behavOps = behavior.operations.size();

	for(int i = 0; i < (int)constraints.size(); i++)
	{
		if((behavAttrs == (int)constraints[i].attributes.size()) && (behavOps == (int)constraints[i].operations.size()))
		{
			if((behavior.attributes == constraints[i].attributes) && (behavior.operations == constraints[i].operations))
			{
				return roles[i];
			}
		}
	}

	return "";
}

