#include "UANManager.h"
#include "AAPlatform.h"

#include <stdio.h>
#include <stdlib.h>
UANManager *UANManager::pinstance = 0;

UANManager *UANManager::Instance()
{
	if(pinstance == 0)
	{
		pinstance = new UANManager();
	}
	return pinstance;
}

UANManager::UANManager()
{
	pthread_mutex_init(&pMutex, NULL);
	actors.clear();
	counters.clear();
	actorNames.clear();
}

UANManager::~UANManager()
{

}

Actor *UANManager::getLocalActor(string uan)
{

	/*
		pthread_mutex_lock (&mutexsum);
  		dotstr.sum += mysum;
   		pthread_mutex_unlock (&mutexsum);

	*/
	pthread_mutex_lock(&pMutex);
	//mutex.lock();
	Actor *result = actors[uan];
	//pMutex.unlock();
	pthread_mutex_unlock (&pMutex);
	return result;
}

ActorName UANManager::generateName(string actorType, Actor *actor, bool role)
{
	ActorName name;

//	pMutex.lock();
	pthread_mutex_lock (&pMutex);

	if(role)
	{
		name.type = actorType;
		name.uan = actorType;
		name.id = 0;
	}
	else
	{
		counters[actorType]++;
		name.id = counters[actorType];
		
		name.type = actorType;
		name.uan = "uan:";
		name.uan += actorType;
		name.uan += ':';
		name.uan += AAPlatform::Instance()->getPlatformName();
		name.uan += ':';
		char idbuffer[20];
		//itoa(name.id,idbuffer,10);
 		sprintf (idbuffer, "%d", name.id);


		name.uan += idbuffer;
	}

	actors[name.uan] = actor;
	actorNames.push_back(name);

	//pMutex.unlock();


	pthread_mutex_unlock (&pMutex);

	return name;
}

void UANManager::getActorNames(vector<ActorName> &data)
{
//	pMutex.lock();

	pthread_mutex_lock (&pMutex);

	data.clear();
	for(int i = 0; i < (int)actorNames.size(); i++)
		data.push_back(actorNames[i]);
	//pMutex.unlock();

	pthread_mutex_unlock (&pMutex);
}
