//#include <sys/types.h>
#include <cctype>
#include <cstdlib>
#include <iostream>
#include <OpenThreads/Thread>
#include <OpenThreads/Mutex>
#include <OpenThreads/Barrier>
#include <queue>
#include <string>
#include "AAPlatform.h"
#include "utility.h"

#ifdef _WIN32
#include <process.h>
#define getpid() _getpid()
#else
#include <unistd.h>
#endif

//OpenThreads::Mutex *m = new OpenThreads::Mutex();
//OpenThreads::Barrier bar;

//int GLOBAL_NUM_THREADS;

// check the working of OpenThreads::Thread::CurrentThread()
static OpenThreads::Thread* CurrentChecker(){
	return OpenThreads::Thread::CurrentThread();
};

//-----------------------------------------------------------------------------
// Custom thread class 
//
class PlatformThread : public OpenThreads::Thread {

public:

////////////////////////////////////////////////////////////////////////////////////////////

  PlatformThread(std::string mode) : OpenThreads::Thread(), 
	     _mode(mode), _quitflag(false) {
  _platform = AAPlatform::Instance();
  };

////////////////////////////////////////////////////////////////////////////////////////////

	PlatformThread(std::string mode, std::string actorName) : OpenThreads::Thread(), 
	     _mode(mode), _quitflag(false) {

		//_actorName = new char[actorName.size()];
	    /*for (n=0; n < actorName.size(); n++) {
		    temp1[n] = actorName[n];
		}*/

		_actorName = Utility::stringToChar(actorName);
		//std::cout << "In PlatformThread: " << _actorName << std::endl;
		//string s = _actorName;
		//std::cout << "In PlatformThread: " << s.size() << std::endl;
		_platform = AAPlatform::Instance();

		_index = -1;
	};

////////////////////////////////////////////////////////////////////////////////////////////

	PlatformThread(std::string mode, std::string actorName, int index) : OpenThreads::Thread(), 
	     _mode(mode), _index(index), _quitflag(false) {

		//_actorName = new char[actorName.size()];
	    _actorName = Utility::stringToChar(actorName);
		_platform = AAPlatform::Instance();
	};

////////////////////////////////////////////////////////////////////////////////////////////

	PlatformThread(std::string mode, std::string actorName, std::string operation) : OpenThreads::Thread(), 
	     _mode(mode), _quitflag(false) {
		
		 _operation = Utility::stringToChar(operation);
		//_actorName = new char[actorName.size()];
	    _actorName = Utility::stringToChar(actorName);

		//_operation = new char[operation.size()];
	   

		_platform = AAPlatform::Instance();
	};

////////////////////////////////////////////////////////////////////////////////////////////

    virtual ~PlatformThread() {};

////////////////////////////////////////////////////////////////////////////////////////////


    virtual void run()
	{
		if (_mode == "create")
		{
			_platform->create(_actorName);	
		}
		else if (_mode == "send")
		{
			_platform->send(_actorName, _operation);
		}
		else if (_mode == "QueueMonitor")
		{
			while (true)
			{	
				_platform->StartMonQue();
				
				_quitmutex.lock();
				if(_quitflag == true) break;
				_quitmutex.unlock();

				Thread::Yield();
			} //end while
		}
    }

////////////////////////////////////////////////////////////////////////////////////////////

    void quit() {

        _quitmutex.lock();
        _quitflag = true;
        _quitmutex.unlock();

    }

////////////////////////////////////////////////////////////////////////////////////////////

    int _index;

private:

	AAPlatform *_platform;
	std::string _mode;
	char* _actorName;
	char* _operation;
    volatile bool _quitflag;
    OpenThreads::Mutex _quitmutex;
};
